\chapter{Related Works}

Frazer and Pitt introduced the LRN algorithm for learning from entailments, \cite{DBLP:conf/icml/FrazierP93} which was a version of the HORN algorithm introduced by Alguin et al. \cite{DBLP:journals/ml/AngluinFP92} with some modifications. The difference is that the queries and counterexamples in the LRN algorithm are not variable assignments, but rather Horn clauses that may or may not be entailed by the target. The type of learning in the HORN algorithm is called \emph{learning from examples}, while the LRN algorithm uses \emph{learning from entailment}.

It has been shown that the Angluin et al.'s learning framework can be used to learn ontologies represented in two versions of the description logic DL-Lite in polynomial time by the number of queries and the size of the queries. \cite{DL_lite} In the same paper it was shown that this was not the case for ontologies formulates in the DL $\mathcal{EL}$. Duarte et al. \cite{duarte2018exactlearner} presnted $\texttt{ExactLearner}$, a tool for exactly learning and teaching such $\mathcal{EL}$ ontologies. While the underlying algorithm of $\texttt{ExactLearner}$ is non-polynomial by the number of queries, evaluations of $\texttt{ExactLearner}$ showed that it terminates for small and medium\footnote{"The selected ontologies range in size from 9 to 11 177 inclusions with signature
sizes ranging from 23 to 9334 concept names and from 2 to 25 role names."  \cite{duarte2018exactlearner}} ontologies. However the description logic DL-$Lite_{\mathcal{R}}$ is exactly learnable in polynomial time with only membership queries or only equavalence queries. \cite{Ozaki2020}



In the paper "Extracting Horn Theories with Queries and Counterexamples" \todo{Add source when \newline paper is published} Anlguin's HORN algorithm was used to query a trained neural network. The neural network had been trained on positive and negative examples of a Horn sentence and so the HORN algorithm was used as a form of neural network verification. If the output of the algorithm indeed matched the target HORN sentence, then one could verify that the neural network had a learnt a reliable representation of the Horn sentence. This approach was similar to that of Weiss et al.\cite{pmlr-v80-weiss18a} who used Angluin’s L* algorithm \cite{ANGLUIN198787} to extract automata from trained \gls{rnn}s.\todo{Using an acronym manager} The L* algorithm also uses membership and equivalence queries, and is designed to extract deterministic finite automata.